/*MIGNEMI MIRKO
MATRICOLA 047000704*/

#include<stdio.h>
#include<string.h>

typedef struct {
                char cognome[80];
                char nome[80];
                long codice;
                int tipo_mansione;
               }dip;

typedef struct {
                long codice;
                int tipo_mansione,giorno;
                char reparto[80];
               }att;
struct atomo {
               att dato;
               struct atomo *next;
               };

void leggi_dip(dip *d);
void ins_or_tab(dip **T,int *n,dip d);
void ricerca(dip *T[8], int N[8]);
void leggi_att(att *at);
void in_lista(struct atomo **tl,att at);
void elimina(struct atomo *L[5]);
void salva(struct atomo *L[5]);
void carica(struct atomo *L[5]);

main(){
        dip *T[8],d;
        int N[8],i,opz;
        struct atomo *L[5], *a;
        att at;
        
        for(i=0;i<8;i++)
         {T[i]=NULL;
          N[i]=0;
          }
        for(i=0;i<5;i++)
           L[i]=NULL;
        
        printf("\t__________GESTIONE DEI DIPENDENTI CENTRO SERVIZI__________\n"); 
        
        do{
            printf("\t\t\t  <<<<<<MENU'>>>>>>>\n");
            printf("1.inserimento dipendente\n2.Ricerca dipendente\n");
            printf("3.Inserimento di una attivita'\n4.Eliminazione di una attivita'\n");
            printf("5.Salva attivita'\n6.Carica attivita'\n");
            printf("0.fine esecuzione\n");
            scanf("%d",&opz);       
            switch(opz){
                        case 1:
                              leggi_dip(&d);
                              i=d.tipo_mansione;
                              ins_or_tab(&T[i],&N[i],d);
                              break;
                        
                        case 2:
                               ricerca(T,N);
                               break;
                        
                        case 3:
                               leggi_att(&at);
                               i=at.giorno;
                               in_lista(&L[i],at);
                               break;
                        
                        case 4:
                               elimina(L);
                               break;
                        
                        case 5:
                               salva(L);
                               break;
                        
                        case 6:
                               carica(L);
                               break;                                   
                        
                        default:;
                        }
        
        
          }while(opz!=0);
           
          for(i=0;i<8;i++)
            free(T[i]);
                     
          for(i=0;i<5;i++)
           while(L[i]!=NULL)
           { a=L[i];
             L[i]=a->next;
             free(a);
           }
}
        
void leggi_dip(dip *d)
{ 
  printf("\nCognome: ");
   scanf("%s",d->cognome);
  printf("Nome: ");
   scanf("%s",d->nome);
  printf("Codice identificativo dipendente: ");
   scanf("%ld",&d->codice);
  printf("tipo di mansione (0...7): ");
   scanf("%d",&d->tipo_mansione); 
 }
 
void ins_or_tab(dip **T,int *n, dip d)
{
     dip *a;
     int i,p,j;
     
     i=d.tipo_mansione;
     a=(dip *)realloc(*T,sizeof(dip)*(*n+1));
     if(a==NULL) return;
     *T=a;
     
     for(p=0;p<*n;p++)
         if(d.codice<(*T)[p].codice)
            break;
     for(j=*n;j>p;j--)
        (*T)[j]=(*T)[j-1];
    
     (*T)[p]=d;
      (*n)++;          
     
 }
void ricerca(dip *T[8], int N[8])
{   
    int j,i;
    long codice;
     
     printf("\nTipo di mansione: ");
      scanf("%d",&i);
     printf("Codice identificativo dipendente: ");
      scanf("%ld",&codice);
      
      for(j=0;j<N[i];j++)
       if(T[i][j].codice==codice)
         {
          printf("\nNome: %s\n",T[i][j].nome);
          printf("Cognome: %s\n",T[i][j].cognome);
          return;
         }
                            
    /* si arriva in questo punto solo se non e' stato trovato*/    
    printf("Non trovato\n");  
      
 }
void leggi_att(att *at)
{
     printf("\nCodice identificativo dipendente: ");
      scanf("%ld",&at->codice);
     printf("tipo_mansione: ");
      scanf("%d",&at->tipo_mansione);
     printf("Giorno della settimana (0=lun; 1=mar;...;4=ven;): ");
      scanf("%d",&at->giorno);
     printf("Reparto: ");
      scanf("%s",at->reparto);
 }
void in_lista(struct atomo **tl, att at)
{
     struct atomo *a;
     
     a=(struct atomo *)malloc(sizeof(struct atomo));
     if(a==NULL) return; 
     a->dato=at;
     a->next=*tl;
     *tl=a;
          
 }
void elimina(struct atomo *L[5])
{    
     struct atomo *a,*l1,*l2;
     int g;
     long codice;
     
     printf("\nGiorno della settimana (0=lun; 1=mar;...;4=ven;): ");
      scanf("%d",&g);
      
     if(L[g]==NULL)
      { printf("Nessun elemento presente\n");
        return;
      }
     
     printf("codice indentificativo dipendente: ");
     scanf("%ld",&codice);
     
     if(codice==L[g]->dato.codice) 
     /* eliminazione dalla testa */
       {  printf("\nTipo mansione: %d\n",L[g]->dato.tipo_mansione);
          printf("Reparto: %s\n",L[g]->dato.reparto);
          a=L[g];
          L[g]=a->next;
          free(a);
          return;
       }
     /* ricerca ed eliminazione in posizione successiva alla prima*/
     l1=L[g];
     l2=l1->next;
     while(l2)
        if(codice==l2->dato.codice)
         {
             printf("\nTipo mansione: %d\n",l2->dato.tipo_mansione);
             printf("Reparto: %s",l2->dato.reparto);
             l1->next=l2->next;
             free(l2);
             return;
         }   
        else  { l1=l1->next;
                l2=l2->next;
              }
                     
     /* si arriva in questo punto solo se non e' stato trovato*/    
    printf("Non trovato\n");                               
 }
void salva(struct atomo *L[5])
{
     FILE *pf;
     att at;
     int i;
     struct atomo *a;
     char nomefile[80];
     
     
     printf("\nNome del file: ");
      scanf("%s",nomefile);
    
     pf=fopen(nomefile,"w");
     if(pf){
            for(i=0;i<5;i++)
             { a=L[i];
               while(a!=NULL)
                { 
                 fprintf(pf,"reparto: %s\n",a->dato.reparto);
                 fprintf(pf,"tipo_mansione: %d\n",a->dato.tipo_mansione);
                 fprintf(pf,"giorno della settimana: %d\n",a->dato.giorno);
                 fprintf(pf,"codice indentificativo dipendente:  %ld\n",a->dato.codice);
                 
                 a=a->next;
                }
             }
            fclose(pf);
         }
                 
 }
 
 
void carica(struct atomo *L[5])
{
     FILE *pf;
     att at;
     int i;
     char nomefile[80];
     
     printf("\nNome del file: ");
      scanf("%s",nomefile);
      
      pf=fopen(nomefile,"r");
      if(pf){
              
              while(!feof(pf))
               {fscanf(pf,"reparto: %s\n",at.reparto);
                fscanf(pf,"tipo_mansione: %d\n",&at.tipo_mansione);
                fscanf(pf,"giorno della settimana: %d\n",&at.giorno);
                fscanf(pf,"codice indentificativo dipendente:  %ld\n",&at.codice);
                i=at.giorno;
                in_lista(&L[i],at);
              }
              fclose(pf);
              }     
 }   
        
        
        
        
        
        
        
                                          
